/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.ripartizione.dbmodel.jooq.tables;


import com.alkemy.sophia.ripartizione.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Indexes;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Keys;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.records.DsrStatisticsSophiaRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class DsrStatisticsSophia extends TableImpl<DsrStatisticsSophiaRecord> {

    private static final long serialVersionUID = 1866565838;

    /**
     * The reference instance of <code>DSR_STATISTICS_SOPHIA</code>
     */
    public static final DsrStatisticsSophia DSR_STATISTICS_SOPHIA = new DsrStatisticsSophia();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<DsrStatisticsSophiaRecord> getRecordType() {
        return DsrStatisticsSophiaRecord.class;
    }

    /**
     * The column <code>DSR_STATISTICS_SOPHIA.IDDSR</code>.
     */
    public final TableField<DsrStatisticsSophiaRecord, String> IDDSR = createField("IDDSR", org.jooq.impl.SQLDataType.VARCHAR(512).nullable(false), this, "");

    /**
     * The column <code>DSR_STATISTICS_SOPHIA.TOTAL_LINES</code>.
     */
    public final TableField<DsrStatisticsSophiaRecord, Long> TOTAL_LINES = createField("TOTAL_LINES", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>DSR_STATISTICS_SOPHIA.TOTAL_RECOGNIZED</code>.
     */
    public final TableField<DsrStatisticsSophiaRecord, Long> TOTAL_RECOGNIZED = createField("TOTAL_RECOGNIZED", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>DSR_STATISTICS_SOPHIA.TOTAL_IDSONG</code>.
     */
    public final TableField<DsrStatisticsSophiaRecord, Long> TOTAL_IDSONG = createField("TOTAL_IDSONG", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>DSR_STATISTICS_SOPHIA.TOTAL_ISWC</code>.
     */
    public final TableField<DsrStatisticsSophiaRecord, Long> TOTAL_ISWC = createField("TOTAL_ISWC", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>DSR_STATISTICS_SOPHIA.TOTAL_ISRC</code>.
     */
    public final TableField<DsrStatisticsSophiaRecord, Long> TOTAL_ISRC = createField("TOTAL_ISRC", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>DSR_STATISTICS_SOPHIA.TOTAL_TITLE_ARTISTS</code>.
     */
    public final TableField<DsrStatisticsSophiaRecord, Long> TOTAL_TITLE_ARTISTS = createField("TOTAL_TITLE_ARTISTS", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>DSR_STATISTICS_SOPHIA.TOTAL_FUZZY</code>.
     */
    public final TableField<DsrStatisticsSophiaRecord, Long> TOTAL_FUZZY = createField("TOTAL_FUZZY", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>DSR_STATISTICS_SOPHIA.TOTAL_MANUAL</code>.
     */
    public final TableField<DsrStatisticsSophiaRecord, Integer> TOTAL_MANUAL = createField("TOTAL_MANUAL", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * Create a <code>DSR_STATISTICS_SOPHIA</code> table reference
     */
    public DsrStatisticsSophia() {
        this(DSL.name("DSR_STATISTICS_SOPHIA"), null);
    }

    /**
     * Create an aliased <code>DSR_STATISTICS_SOPHIA</code> table reference
     */
    public DsrStatisticsSophia(String alias) {
        this(DSL.name(alias), DSR_STATISTICS_SOPHIA);
    }

    /**
     * Create an aliased <code>DSR_STATISTICS_SOPHIA</code> table reference
     */
    public DsrStatisticsSophia(Name alias) {
        this(alias, DSR_STATISTICS_SOPHIA);
    }

    private DsrStatisticsSophia(Name alias, Table<DsrStatisticsSophiaRecord> aliased) {
        this(alias, aliased, null);
    }

    private DsrStatisticsSophia(Name alias, Table<DsrStatisticsSophiaRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> DsrStatisticsSophia(Table<O> child, ForeignKey<O, DsrStatisticsSophiaRecord> key) {
        super(child, key, DSR_STATISTICS_SOPHIA);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.DSR_STATISTICS_SOPHIA_IX_DSR_STATISTICS_8055281B0DD3DFFB, Indexes.DSR_STATISTICS_SOPHIA_IX_DSR_STATISTICS_SOPHIA_8055281B0DD3DFFB, Indexes.DSR_STATISTICS_SOPHIA_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<DsrStatisticsSophiaRecord> getPrimaryKey() {
        return Keys.KEY_DSR_STATISTICS_SOPHIA_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<DsrStatisticsSophiaRecord>> getKeys() {
        return Arrays.<UniqueKey<DsrStatisticsSophiaRecord>>asList(Keys.KEY_DSR_STATISTICS_SOPHIA_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrStatisticsSophia as(String alias) {
        return new DsrStatisticsSophia(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrStatisticsSophia as(Name alias) {
        return new DsrStatisticsSophia(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public DsrStatisticsSophia rename(String name) {
        return new DsrStatisticsSophia(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public DsrStatisticsSophia rename(Name name) {
        return new DsrStatisticsSophia(name, null);
    }
}
